Module ModuleMain

    Public Declare Sub keybd_event Lib "user32 " (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
    Public Declare Function GetKeyState Lib "user32 " (ByVal nVirtKey As Long) As Int16
    Public ToolBarImageSize As String
    Public CaspLockKeyStatus As Boolean
    Public NumLockKeyStatus As Boolean
    Public InsertKeyStatus As Boolean
    Public Const KEYSTATUS_KEYUP = 0
    Public Const KEYSTATUS_KEYDOWN = 1
    Public ActiveRichTextBox As System.Windows.Forms.RichTextBox
    Public ActiveMdiChildForm As System.Windows.Forms.Form
    Public FileDialogFilter As String = "ļ(*.*)|*.*|ıļ(*.txt)|*.txt|INIļ(*.ini)|*.ini|ļ(*.bat)|*.bat|ıļ(*.rtf)|*.rtf" & _
        "|HTMLļ(*.htm;*.html)|*.htm;*.html|CSSļ(*.css)|*.css|XMLļ(*.xml)|*.xml"
    Public ImageDialogFilter As String = "ͼƬļ(*.jpg;*.jpeg;*.gif;*.png;*.bmp)|*.jpg;*.jpeg;*.gif;*.png;*.bmp" & _
        "|JPGͼļ(*.jpg;*.jpeg)|*.jpg;*jpeg|GIFͼļ(*.gif)|*.gif|PNGͼļ(*.png)|*.png|λͼͼ(*.bmp)|*.bmp"

#Region "ťͲ˵"

    Public NewForm As frmDoc = New frmDoc
    Public Const StyleOffice2003 As String = "Office2003"
    Public Const StyleRibbon As String = "Ribbon"
    Public Const DelectFileRecycleBin As String = "RecycleBin"
    Public Const DelectFilePermanently As String = "Permanently"
    Public Const FileIconStyleClassic As String = "Classic"
    Public Const FileIconStyleXP As String = "XP"
    Public Const FileOpenStyleIntegration As String = "Integration"
    Public Const FileOpenStyleExternalExceptionUseIntegeration As String = "ExternalExceptionUseIntegeration"
    Public Const FileOpenStyleExternalExceptionUseExternal As String = "ExternalExceptionUseExternal"

    Public Function GetActiveFilePath() As String
        ActiveMdiChildForm = frmMain.ActiveMdiChild
        Return ActiveMdiChildForm.Text.ToString.Replace(" *", "").Trim()
    End Function

    Public Function GetActiveFileExtension() As String
        ActiveMdiChildForm = frmMain.ActiveMdiChild
        Return ActiveMdiChildForm.Text.ToString.Replace(" *", "").ToLower.Trim()
    End Function

    Public Sub NewDoc()
        Static Number As Integer
        NewForm = New frmDoc
        Number += 1
        NewForm.MdiParent = frmMain
        NewForm.Text = "δļ" & CStr(Number)
        NewForm.Show()
        Static ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        Static ActiveMdiChildForm = frmMain.ActiveMdiChild
    End Sub

    Public Sub OpenFile()
        With frmMain.OpenFileDialog
            .RestoreDirectory = True
            .Filter = FileDialogFilter
            If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                If .FileName.EndsWith(".rtf") = True Then
                    NewDoc()
                    NewForm.rtxMain.LoadFile(.FileName, RichTextBoxStreamType.RichText)
                    NewForm.Text = .FileName
                    If .ReadOnlyChecked = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
                    frmMain.tslblStatus.Text = "ڴļ " & frmMain.OpenFileDialog.FileName
                    frmMain.tslblStatus.Text = "Ѵļ " & frmMain.OpenFileDialog.FileName
                    frmMain.tmrChangeStatusText.Enabled = True
                Else
                    NewDoc()
                    NewForm.rtxMain.LoadFile(.FileName, RichTextBoxStreamType.PlainText)
                    NewForm.Text = .FileName
                    If .ReadOnlyChecked = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
                    frmMain.tslblStatus.Text = "ڴļ " & frmMain.OpenFileDialog.FileName
                    frmMain.tslblStatus.Text = "Ѵļ " & frmMain.OpenFileDialog.FileName
                    frmMain.tmrChangeStatusText.Enabled = True
                    FormatEnabled(False)
                End If
                frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved) : .FileName = ""
            End If
        End With
    End Sub

    Public Sub OpenFile(ByVal Path As String)
        If Path.EndsWith(".rtf") = True Then
            ModuleMain.NewDoc()
            ModuleMain.NewForm.rtxMain.LoadFile(Path, RichTextBoxStreamType.RichText)
            ModuleMain.NewForm.Text = Path
            If My.Computer.FileSystem.GetFileInfo(Path).IsReadOnly = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
            frmMain.tslblStatus.Text = "ڴļ " & Path
            frmMain.tslblStatus.Text = "Ѵļ " & Path
            frmMain.tmrChangeStatusText.Enabled = True
        Else
            ModuleMain.NewDoc()
            ModuleMain.NewForm.rtxMain.LoadFile(Path, RichTextBoxStreamType.PlainText)
            ModuleMain.NewForm.Text = Path
            If My.Computer.FileSystem.GetFileInfo(Path).IsReadOnly = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
            frmMain.tslblStatus.Text = "ڴļ " & Path
            frmMain.tslblStatus.Text = "Ѵļ " & Path
            frmMain.tmrChangeStatusText.Enabled = True
            ModuleMain.FormatEnabled(False)
        End If
        frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved)
    End Sub

    Public Sub SaveFile()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        With frmMain.SaveFileDialog
            .RestoreDirectory = True
            .Filter = FileDialogFilter
            If (ActiveMdiChildForm.Text.StartsWith("δļ") = True Or ActiveMdiChildForm.Text.EndsWith(" *") = True) And ActiveMdiChildForm.Text.StartsWith("δļ") = True Then
                If .ShowDialog = System.Windows.Forms.DialogResult.OK And .FileName.Length > 0 Then
                    If GetActiveFileExtension().EndsWith(".rtf") = True Then
                        ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.RichText)
                    Else
                        ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.PlainText)
                    End If
                    ActiveMdiChildForm.Text = .FileName
                    frmMain.tslblStatus.Text = "ڱļ " & frmMain.OpenFileDialog.FileName
                    frmMain.tslblStatus.Text = "ѱļ " & frmMain.OpenFileDialog.FileName
                    frmMain.tmrChangeStatusText.Enabled = True
                End If
            ElseIf GetActiveFileExtension().EndsWith(".rtf") = True Then
                ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.RichText)
                ActiveMdiChildForm.Text = GetActiveFilePath()
            Else
                ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.PlainText)
                ActiveMdiChildForm.Text = GetActiveFilePath()
            End If
            frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved) : .FileName = ""
        End With
    End Sub

    Public Sub SaveAsFile()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        With frmMain.SaveFileDialog
            .RestoreDirectory = True
            .Filter = FileDialogFilter
            If .ShowDialog = System.Windows.Forms.DialogResult.OK And .FileName.Length > 0 Then
                If GetActiveFileExtension().EndsWith(".rtf") = True Then
                    ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.RichText)
                    ActiveMdiChildForm.Text = GetActiveFilePath()
                Else
                    ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.PlainText)
                    ActiveMdiChildForm.Text = GetActiveFilePath()
                End If
                .FileName = ""
            End If
        End With
    End Sub

    Public Sub SaveAllFile()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        For i As Integer = 0 To frmMain.MdiChildren.Length - 1
            With frmMain.SaveFileDialog
                .RestoreDirectory = True
                .Filter = FileDialogFilter
                If ActiveMdiChildForm.Text.StartsWith("δļ") = True Or ActiveMdiChildForm.Text.EndsWith(" *") = True Then
                    If .ShowDialog = System.Windows.Forms.DialogResult.OK And .FileName.Length > 0 Then
                        ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.RichText)
                        frmMain.tslblStatus.Text = "ڱļ " & frmMain.OpenFileDialog.FileName
                        frmMain.tslblStatus.Text = "ѱļ " & frmMain.OpenFileDialog.FileName
                        frmMain.tmrChangeStatusText.Enabled = True
                        ActiveMdiChildForm.Text = .FileName
                    Else : Exit Sub
                    End If
                ElseIf GetActiveFileExtension().EndsWith(".rtf") = True Then
                    ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.RichText)
                    ActiveMdiChildForm.Text = .FileName
                Else
                    ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.RichText)
                    ActiveMdiChildForm.Text = .FileName
                End If
                frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved) : .FileName = ""
            End With
        Next
    End Sub

    Public Sub SelectAll()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionStart = 0
        ActiveRichTextBox.SelectionLength = ActiveRichTextBox.TextLength
    End Sub

    Public Sub Cut()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Cut()
    End Sub

    Public Sub CutAllText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.SelectAll() : ActiveRichTextBox.Cut()
    End Sub

    Public Sub Copy()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Copy()
    End Sub

    Public Sub CopyAllText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        Dim SelectIndex As Integer = ActiveRichTextBox.SelectionStart, SelectLenth As Integer = ActiveRichTextBox.SelectionLength
        ActiveRichTextBox.SelectAll() : ActiveRichTextBox.Copy()
        ActiveRichTextBox.SelectionStart = SelectIndex : ActiveRichTextBox.SelectionLength = SelectLenth
    End Sub

    Public Sub Paste()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If ActiveRichTextBox.SelectedText <> "" Then ActiveRichTextBox.SelectionStart = ActiveRichTextBox.SelectionStart + ActiveRichTextBox.SelectionLength = 0
        ActiveRichTextBox.Paste()
    End Sub

    Public Sub Undo()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Undo()
    End Sub

    Public Sub Redo()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Redo()
    End Sub

    Public Sub Bold()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Bold, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Bold, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "δõʵ" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Bold, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub Italic()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Italic, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Italic, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "δõʵ" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Italic, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub UnderLine()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Underline, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Underline, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "δõʵ" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Underline, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub StrikoutLine()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Strikeout, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Strikeout, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "δõʵ" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Strikeout, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
    End Sub

    Public Sub ChangeFontSize()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Dim FontSize As Single = CSng(frmMain.tscmbFontSize.SelectedItem.ToString)
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, FontSize, ActiveRichTextBox.SelectionFont.Style)
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, FontSize, ActiveRichTextBox.SelectionFont.Style)
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "δõʵ" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, FontSize, ActiveRichTextBox.SelectionFont.Style)
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub ChangeFontStyle()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Dim Font As System.Drawing.FontFamily = New FontFamily(System.Convert.ToString(frmMain.tscmbFontStyle.SelectedItem.ToString))
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(Font, ActiveRichTextBox.SelectionFont.Size, ActiveRichTextBox.SelectionFont.Style)
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
                    ActiveRichTextBox.SelectionFont = New Font(Font, ActiveRichTextBox.SelectionFont.Size, ActiveRichTextBox.SelectionFont.Style)
                    i += 1
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "δõʵ" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
                    ActiveRichTextBox.SelectionFont = New Font(Font, ActiveRichTextBox.SelectionFont.Size, ActiveRichTextBox.SelectionFont.Style)
                    i += 1
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub Bullets()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionBullet = Not ActiveRichTextBox.SelectionBullet
    End Sub

    Public Sub SuperScript(ByVal Enabled As Boolean)
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If Enabled = True Then ActiveRichTextBox.SelectionCharOffset = CInt(frmMain.tstxtSuperScript.Text) Else ActiveRichTextBox.SelectionCharOffset = 0
    End Sub

    Public Sub SubScript(ByVal Enabled As Boolean)
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If Enabled = True Then ActiveRichTextBox.SelectionCharOffset = CInt(frmMain.tstxtSubScript.Text) Else ActiveRichTextBox.SelectionCharOffset = 0
    End Sub

    Public Sub LeftAlignText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionAlignment = HorizontalAlignment.Left
    End Sub

    Public Sub CenterAlignText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionAlignment = HorizontalAlignment.Center
    End Sub

    Public Sub RightAlignText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionAlignment = HorizontalAlignment.Right
    End Sub

    Public Sub PageSetting()

    End Sub

    Public Sub PrintFile()

    End Sub

    Public Sub PrintPreview()

    End Sub

    Public Sub InsertImage()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        Dim Image As System.Drawing.Bitmap = Nothing
        With frmMain.OpenFileDialog
            .Filter = ImageDialogFilter
            .RestoreDirectory = True
            If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                Image = System.Drawing.Bitmap.FromFile(.FileName)
            End If
            Dim DataObject As DataObject = New DataObject
            Dim OldDataOnClipboard As DataObject = Clipboard.GetDataObject
            DataObject.SetData(DataFormats.Bitmap, True, Image)
            Clipboard.SetDataObject(DataObject, True)
            Dim Format As DataFormats.Format = DataFormats.GetFormat(DataFormats.Bitmap)
            If ActiveRichTextBox.CanPaste(Format) Then ActiveRichTextBox.Paste(Format)
            Clipboard.SetDataObject(OldDataOnClipboard, True)
        End With
    End Sub

    Public Sub DeleteFileFormDisk()
        ActiveMdiChildForm = frmMain.ActiveMdiChild
        Dim FilePath As String = GetActiveFilePath()
        If FilePath.StartsWith("δļ") <> True Then
            Try
                Select Case My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "DelectFileTo", Nothing)
                    Case ModuleMain.DelectFileRecycleBin : My.Computer.FileSystem.DeleteFile(FilePath, FileIO.UIOption.AllDialogs, FileIO.RecycleOption.SendToRecycleBin) : ActiveMdiChildForm.Close()
                    Case ModuleMain.DelectFilePermanently : My.Computer.FileSystem.DeleteFile(FilePath, FileIO.UIOption.AllDialogs, FileIO.RecycleOption.DeletePermanently) : ActiveMdiChildForm.Close()
                    Case Nothing : My.Computer.FileSystem.DeleteFile(FilePath, FileIO.UIOption.AllDialogs, FileIO.RecycleOption.SendToRecycleBin) : ActiveMdiChildForm.Close()
                End Select
            Catch ex As Exception
            End Try
        Else
            MessageBox.Show("ȱɾļ", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Public Sub ShowFontDialog()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        frmMain.FontDialog.Font = ActiveRichTextBox.SelectionFont
        If frmMain.FontDialog.ShowDialog = System.Windows.Forms.DialogResult.OK Then
            ActiveRichTextBox.SelectionFont = frmMain.FontDialog.Font
            frmMain.tsbBold.Checked = frmMain.FontDialog.Font.Bold
            frmMain.tsbItalic.Checked = frmMain.FontDialog.Font.Italic
            frmMain.tsbUnderLine.Checked = frmMain.FontDialog.Font.Underline
            frmMain.tsbStrikoutLine.Checked = frmMain.FontDialog.Font.Strikeout
            frmMain.tscmbFontStyle.Text = frmMain.FontDialog.Font.Name
            frmMain.tscmbFontSize.Text = frmMain.FontDialog.Font.Size
        End If
    End Sub

    Public Sub ShowFontColorDialog()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        frmMain.ColorDialog.Color = ActiveRichTextBox.SelectionColor
        If frmMain.ColorDialog.ShowDialog = System.Windows.Forms.DialogResult.OK Then ActiveRichTextBox.SelectionColor = frmMain.ColorDialog.Color
    End Sub

#End Region

    Public Sub ChangeToolBarImageSize(ByVal Size As String)
        With frmMain
            If Size = 16 Then
                .tsbNew.Image = My.Resources.½ : .tsbOpen.Image = My.Resources.
                .tsbSave.Image = My.Resources. : .tsbSaveAll.Image = My.Resources.ȫ
                .tsbPrint.Image = My.Resources.ӡ : .tsbPrintPreview.Image = My.Resources.ӡԤ
                .tsbCut.Image = My.Resources. : .tsbCopy.Image = My.Resources.
                .tsbPaste.Image = My.Resources.ճ : .tsbUndo.Image = My.Resources.
                .tsbRedo.Image = My.Resources. : .tsbFind.Image = My.Resources.
                .tsmiZoom.Image = My.Resources.ʾ
                .tsbBold.Image = My.Resources.Ӵ : .tsbItalic.Image = My.Resources.б
                .tsbUnderLine.Image = My.Resources.» : .tsbStrikoutLine.Image = My.Resources.ɾ
                .tsbLeft.Image = My.Resources. : .tsbCenter.Image = My.Resources. : .tsbRight.Image = My.Resources.Ҷ
                .tsbFont.Image = My.Resources. : .tsbFontColor.Image = My.Resources.ɫ
                .tsbInsterImage.Image = My.Resources.ͼƬ : ToolBarImageSize = 16
            ElseIf Size = 32 Then
                .tsbNew.Image = My.Resources.½32 : .tsbOpen.Image = My.Resources.32
                .tsbSave.Image = My.Resources.32 : .tsbSaveAll.Image = My.Resources.ȫ32
                .tsbPrint.Image = My.Resources.ӡ32 : .tsbPrintPreview.Image = My.Resources.ӡԤ32
                .tsbCut.Image = My.Resources.32 : .tsbCopy.Image = My.Resources.32
                .tsbPaste.Image = My.Resources.ճ32 : .tsbUndo.Image = My.Resources.32
                .tsbRedo.Image = My.Resources.32 : .tsbFind.Image = My.Resources.32
                .tsmiZoom.Image = My.Resources.ʾ32 : ToolBarImageSize = 32
            End If
        End With
    End Sub

    Public Sub FormatEnabled(ByVal Enabled As Boolean)
        frmMain.tsrFormat.Enabled = Enabled
        frmMain.tsmiFormat.Enabled = Enabled
        frmMain.tsmiZoom.Enabled = Enabled
    End Sub

    Public Sub ToolBarButtonAndMenuItemEnabled(ByVal Enabled As Boolean)
        frmOptions.chkWordWrap.Enabled = Enabled
        frmMain.tsbSave.Enabled = Enabled
        frmMain.tsbSaveAll.Enabled = Enabled
        frmMain.tsbPrint.Enabled = Enabled
        frmMain.tsbPrintPreview.Enabled = Enabled
        frmMain.tsbCut.Enabled = Enabled
        frmMain.tsbCopy.Enabled = Enabled
        frmMain.tsbPaste.Enabled = Enabled
        frmMain.tsbUndo.Enabled = Enabled
        frmMain.tsbRedo.Enabled = Enabled
        frmMain.tsbFind.Enabled = Enabled
        frmMain.tsmiZoom.Enabled = Enabled
        frmMain.tsrFormat.Enabled = Enabled
        frmMain.tsmiFileSave.Enabled = Enabled
        frmMain.tsmiFileSaveAs.Enabled = Enabled
        frmMain.tsmiFileSaveAll.Enabled = Enabled
        frmMain.tsmiFilePageSetting.Enabled = Enabled
        frmMain.tsmiFilePrint.Enabled = Enabled
        frmMain.tsmiFilePrintPreview.Enabled = Enabled
        frmMain.tsmiFileDeleteFileFormDisk.Enabled = Enabled
        frmMain.tsmiEdit.Enabled = Enabled
        frmMain.tsmiFormat.Enabled = Enabled
    End Sub
End Module
