﻿Module ModuleMain

    Public Declare Sub keybd_event Lib "user32 " (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
    Public Declare Function GetKeyState Lib "user32 " (ByVal nVirtKey As Long) As Int16
    Public ToolBarImageSize As String
    Public CaspLockKeyStatus As Boolean
    Public NumLockKeyStatus As Boolean
    Public InsertKeyStatus As Boolean
    Public Const KEYSTATUS_KEYUP = 0
    Public Const KEYSTATUS_KEYDOWN = 1
    Public ActiveRichTextBox As System.Windows.Forms.RichTextBox '= CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
    Public ActiveMdiChildForm As System.Windows.Forms.Form '= frmMain.ActiveMdiChild
    Public FileDialogFilter As String = "所有文件(*.*)|*.*|纯文本文件(*.txt)|*.txt|INI文件(*.ini)|*.ini|批处理文件(*.bat)|*.bat|富文本文件(*.rtf)|*.rtf" & _
        "|HTML文件(*.htm;*.html)|*.htm;*.html|CSS文件(*.css)|*.css|XML文件(*.xml)|*.xml"
    Public ImageDialogFilter As String = "所有图片文件(*.jpg;*.jpeg;*.gif;*.png;*.bmp)|*.jpg;*.jpeg;*.gif;*.png;*.bmp" & _
        "|JPG图像文件(*.jpg;*.jpeg)|*.jpg;*jpeg|GIF图像文件(*.gif)|*.gif|PNG图像文件(*.png)|*.png|位图图像(*.bmp)|*.bmp"

#Region "按钮和菜单项按钮过程"

    Public NewForm As frmDoc = New frmDoc
    Public Const StyleOffice2003 As String = "Office2003"
    Public Const StyleRibbon As String = "Ribbon"
    Public Const DelectFileRecycleBin As String = "RecycleBin"
    Public Const DelectFilePermanently As String = "Permanently"
    Public Const FileIconStyleClassic As String = "Classic"
    Public Const FileIconStyleXP As String = "XP"
    Public Const FileOpenStyleIntegration As String = "Integration"
    Public Const FileOpenStyleExternalExceptionUseIntegeration As String = "ExternalExceptionUseIntegeration"
    Public Const FileOpenStyleExternalExceptionUseExternal As String = "ExternalExceptionUseExternal"

    Public Function GetActiveFilePath() As String
        ActiveMdiChildForm = frmMain.ActiveMdiChild
        Return ActiveMdiChildForm.Text.ToString.Replace(" *", "").Trim()
    End Function

    Public Function GetActiveFileExtension() As String
        ActiveMdiChildForm = frmMain.ActiveMdiChild
        Return ActiveMdiChildForm.Text.ToString.Replace(" *", "").ToLower.Trim()
    End Function

    Public Sub NewDoc()
        Static Number As Integer
        NewForm = New frmDoc
        Number += 1
        NewForm.MdiParent = frmMain
        NewForm.Text = "未命名文件" & CStr(Number)
        NewForm.Show()
        Static ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        Static ActiveMdiChildForm = frmMain.ActiveMdiChild
    End Sub

    Public Sub OpenFile()
        With frmMain.OpenFileDialog
            .RestoreDirectory = True
            .Filter = FileDialogFilter
            If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                If .FileName.EndsWith(".rtf") = True Then
                    NewDoc()
                    NewForm.rtxMain.LoadFile(.FileName, RichTextBoxStreamType.RichText)
                    NewForm.Text = .FileName
                    If .ReadOnlyChecked = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
                    frmMain.LabelStatus.Text = "正在打开文件 " & frmMain.OpenFileDialog.FileName
                    frmMain.LabelStatus.Text = "已打开文件 " & frmMain.OpenFileDialog.FileName
                    frmMain.tmrChangeStatusText.Enabled = True
                Else
                    NewDoc()
                    NewForm.rtxMain.LoadFile(.FileName, RichTextBoxStreamType.PlainText)
                    NewForm.Text = .FileName
                    If .ReadOnlyChecked = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
                    frmMain.LabelStatus.Text = "正在打开文件 " & frmMain.OpenFileDialog.FileName
                    frmMain.LabelStatus.Text = "已打开文件 " & frmMain.OpenFileDialog.FileName
                    frmMain.tmrChangeStatusText.Enabled = True
                    FormatEnabled(False)
                End If
                frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved) : .FileName = ""
            End If
        End With
    End Sub

    Public Sub OpenFile(ByVal Path As String)
        If Path.EndsWith(".rtf") = True Then
            ModuleMain.NewDoc()
            ModuleMain.NewForm.rtxMain.LoadFile(Path, RichTextBoxStreamType.RichText)
            ModuleMain.NewForm.Text = Path
            If My.Computer.FileSystem.GetFileInfo(Path).IsReadOnly = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
            frmMain.LabelStatus.Text = "正在打开文件 " & Path
            frmMain.LabelStatus.Text = "已打开文件 " & Path
            frmMain.tmrChangeStatusText.Enabled = True
        Else
            ModuleMain.NewDoc()
            ModuleMain.NewForm.rtxMain.LoadFile(Path, RichTextBoxStreamType.PlainText)
            ModuleMain.NewForm.Text = Path
            If My.Computer.FileSystem.GetFileInfo(Path).IsReadOnly = True Then NewForm.rtxMain.ReadOnly = True : NewForm.rtxMain.BackColor = System.Drawing.Color.LightGray
            frmMain.LabelStatus.Text = "正在打开文件 " & Path
            frmMain.LabelStatus.Text = "已打开文件 " & Path
            frmMain.tmrChangeStatusText.Enabled = True
            ModuleMain.FormatEnabled(False)
        End If
        frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved)
    End Sub

    Public Sub SaveFile()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        With frmMain.SaveFileDialog
            .RestoreDirectory = True
            .Filter = FileDialogFilter
            If (ActiveMdiChildForm.Text.StartsWith("未命名文件") = True Or ActiveMdiChildForm.Text.EndsWith(" *") = True) And ActiveMdiChildForm.Text.StartsWith("未命名文件") = True Then
                If .ShowDialog = System.Windows.Forms.DialogResult.OK And .FileName.Length > 0 Then
                    If GetActiveFileExtension().EndsWith(".rtf") = True Then
                        ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.RichText)
                    Else
                        ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.PlainText)
                    End If
                    ActiveMdiChildForm.Text = .FileName
                    frmMain.LabelStatus.Text = "正在保存文件 " & frmMain.OpenFileDialog.FileName
                    frmMain.LabelStatus.Text = "已保存文件 " & frmMain.OpenFileDialog.FileName
                    frmMain.tmrChangeStatusText.Enabled = True
                End If
            ElseIf GetActiveFileExtension().EndsWith(".rtf") = True Then
                ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.RichText)
                ActiveMdiChildForm.Text = GetActiveFilePath()
            Else
                ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.PlainText)
                ActiveMdiChildForm.Text = GetActiveFilePath()
            End If
            frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved) : .FileName = ""
        End With
    End Sub

    Public Sub SaveAsFile()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        With frmMain.SaveFileDialog
            .RestoreDirectory = True
            .Filter = FileDialogFilter
            If .ShowDialog = System.Windows.Forms.DialogResult.OK And .FileName.Length > 0 Then
                If GetActiveFileExtension().EndsWith(".rtf") = True Then
                    ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.RichText)
                    ActiveMdiChildForm.Text = GetActiveFilePath()
                Else
                    ActiveRichTextBox.SaveFile(GetActiveFilePath, RichTextBoxStreamType.PlainText)
                    ActiveMdiChildForm.Text = GetActiveFilePath()
                End If
                .FileName = ""
            End If
        End With
    End Sub

    Public Sub SaveAllFile()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        For i As Integer = 0 To frmMain.MdiChildren.Length - 1
            With frmMain.SaveFileDialog
                .RestoreDirectory = True
                .Filter = FileDialogFilter
                If ActiveMdiChildForm.Text.StartsWith("未命名文件") = True Or ActiveMdiChildForm.Text.EndsWith(" *") = True Then
                    If .ShowDialog = System.Windows.Forms.DialogResult.OK And .FileName.Length > 0 Then
                        ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.RichText)
                        frmMain.LabelStatus.Text = "正在保存文件 " & frmMain.OpenFileDialog.FileName
                        frmMain.LabelStatus.Text = "已保存文件 " & frmMain.OpenFileDialog.FileName
                        frmMain.tmrChangeStatusText.Enabled = True
                        ActiveMdiChildForm.Text = .FileName
                    Else : Exit Sub
                    End If
                ElseIf GetActiveFileExtension().EndsWith(".rtf") = True Then
                    ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.RichText)
                    ActiveMdiChildForm.Text = .FileName
                Else
                    ActiveRichTextBox.SaveFile(.FileName, RichTextBoxStreamType.PlainText)
                    ActiveMdiChildForm.Text = .FileName
                End If
                frmDoc.CurrentFileChangedOrSaved(frmDoc.FileState.FileSaved) : .FileName = ""
            End With
        Next
    End Sub

    Public Sub SelectAll()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionStart = 0     'ActiveRichTextBox.SelectAll()
        ActiveRichTextBox.SelectionLength = ActiveRichTextBox.TextLength
    End Sub

    Public Sub Cut()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Cut()
    End Sub

    Public Sub CutAllText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.SelectAll() : ActiveRichTextBox.Cut()
    End Sub

    Public Sub Copy()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Copy()
    End Sub

    Public Sub CopyAllText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        Dim SelectIndex As Integer = ActiveRichTextBox.SelectionStart, SelectLenth As Integer = ActiveRichTextBox.SelectionLength
        ActiveRichTextBox.SelectAll() : ActiveRichTextBox.Copy()
        ActiveRichTextBox.SelectionStart = SelectIndex : ActiveRichTextBox.SelectionLength = SelectLenth
    End Sub

    Public Sub Paste()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If ActiveRichTextBox.SelectedText <> "" Then ActiveRichTextBox.SelectionStart = ActiveRichTextBox.SelectionStart + ActiveRichTextBox.SelectionLength = 0
        ActiveRichTextBox.Paste()
    End Sub

    Public Sub Undo()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Undo()
    End Sub

    Public Sub Redo()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.Redo()
    End Sub

    Public Sub Bold()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Bold, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Bold, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "未将对象引用设置到对象的实例。" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Bold, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
        'ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        'ActiveMdiChildForm.SuspendLayout()
        'If ActiveRichTextBox.SelectionFont IsNot Nothing Then
        '    Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '    Dim currentFontBold As Boolean = ActiveRichTextBox.SelectionFont.Bold, currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic
        '    Dim currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline, currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '    newFontStyle = IIf(currentFontBold, FontStyle.Regular, FontStyle.Bold) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '    IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '    ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        'Else : frmDoc.DeleteHandler()
        '    Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
        '    Dim currentFontBold As Boolean = frmMain.ButtonBold.Checked
        '    For i As Integer = Pos To Pos + Len - 1
        '        ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
        '        Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '        Dim currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic, currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline
        '        Dim currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '        newFontStyle = IIf(currentFontBold, FontStyle.Regular, FontStyle.Bold) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '        IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '        ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        '    Next
        '    ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len : frmDoc.AddNewHandler()
        'End If
        'ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub Italic()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Italic, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Italic, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "未将对象引用设置到对象的实例。" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Italic, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
        'ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        'ActiveMdiChildForm.SuspendLayout()
        'If ActiveRichTextBox.SelectionFont IsNot Nothing Then
        '    Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '    Dim currentFontBold As Boolean = ActiveRichTextBox.SelectionFont.Bold, currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic
        '    Dim currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline, currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '    newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Regular, FontStyle.Italic) Or _
        '    IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '    ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        'Else : frmDoc.DeleteHandler()
        '    Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
        '    Dim currentFontBold As Boolean = frmMain.ButtonBold.Checked
        '    For i As Integer = Pos To Pos + Len - 1
        '        ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
        '        Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '        Dim currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic, currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline
        '        Dim currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '        newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '         IIf(currentFontUnderLine, FontStyle.Regular, FontStyle.Underline) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '        ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        '    Next
        '    ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len : frmDoc.AddNewHandler()
        'End If
        'ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub UnderLine()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Underline, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Underline, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "未将对象引用设置到对象的实例。" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Underline, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        'ActiveMdiChildForm.ResumeLayout()
        'ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        'ActiveMdiChildForm.SuspendLayout()
        'If ActiveRichTextBox.SelectionFont IsNot Nothing Then
        '    Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '    Dim currentFontBold As Boolean = ActiveRichTextBox.SelectionFont.Bold, currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic
        '    Dim currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline, currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '    newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '     IIf(currentFontUnderLine, FontStyle.Regular, FontStyle.Underline) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '    ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        'Else : frmDoc.DeleteHandler()
        '    Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
        '    Dim currentFontBold As Boolean = frmMain.ButtonBold.Checked
        '    For i As Integer = Pos To Pos + Len - 1
        '        ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
        '        Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '        Dim currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic, currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline
        '        Dim currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '        newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '        IIf(currentFontUnderLine, FontStyle.Regular, FontStyle.Underline) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '        ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        '    Next
        '    ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len : frmDoc.AddNewHandler()
        'End If
        'ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub StrikoutLine()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Strikeout, System.Drawing.FontStyle))
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Strikeout, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "未将对象引用设置到对象的实例。" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, ActiveRichTextBox.SelectionFont.Size, CType(ActiveRichTextBox.SelectionFont.Style + System.Drawing.FontStyle.Strikeout, System.Drawing.FontStyle))
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
        'ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        'ActiveMdiChildForm.SuspendLayout()
        'If ActiveRichTextBox.SelectionFont IsNot Nothing Then
        '    Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '    Dim currentFontBold As Boolean = ActiveRichTextBox.SelectionFont.Bold, currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic
        '    Dim currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline, currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '    newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '    IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Regular, FontStyle.Strikeout)
        '    ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        '    ActiveRichTextBox.SelectionCharOffset = 1
        'Else : frmDoc.DeleteHandler()
        '    Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
        '    Dim currentFontBold As Boolean = frmMain.ButtonBold.Checked
        '    For i As Integer = Pos To Pos + Len - 1
        '        ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
        '        Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '        Dim currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic, currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline
        '        Dim currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '        newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '        IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Regular, FontStyle.Strikeout)
        '        ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, currentFont.Size, newFontStyle)
        '    Next
        '    ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len : frmDoc.AddNewHandler()
        'End If
        'ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub ChangeFontSize()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Dim FontSize As Single = CSng(frmMain.ComboFontSize.SelectedItem.ToString)
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, FontSize, ActiveRichTextBox.SelectionFont.Style)
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, FontSize, ActiveRichTextBox.SelectionFont.Style)
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "未将对象引用设置到对象的实例。" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1 : i += 1
                    ActiveRichTextBox.SelectionFont = New Font(ActiveRichTextBox.SelectionFont.Name, FontSize, ActiveRichTextBox.SelectionFont.Style)
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
        'ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        'ActiveMdiChildForm.SuspendLayout()
        'If frmMain.ComboFontSize.SelectedIndex <> -1 Then
        '    Dim FontSize As Single = System.Convert.ToSingle(frmMain.ComboFontSize.SelectedItem.ToString)
        '    If ActiveRichTextBox.SelectionFont IsNot Nothing Then
        '        Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '        Dim currentFontBold As Boolean = ActiveRichTextBox.SelectionFont.Bold, currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic
        '        Dim currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline, currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '        newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '        IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '        ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, FontSize, newFontStyle)
        '    Else
        '        Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
        '        Dim currentFontBold As Boolean = frmMain.ButtonBold.Checked
        '        For i As Integer = Pos To Pos + Len - 1
        '            ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
        '            Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '            Dim currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic, currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline
        '            Dim currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '            newFontStyle = IIf(currentFontBold, FontStyle.Regular, FontStyle.Bold) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '            IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '            ActiveRichTextBox.SelectionFont = New Font(currentFont.FontFamily, FontSize, newFontStyle)
        '        Next
        '        ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len 
        '    End If
        'End If
        'ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub ChangeFontStyle()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        ActiveMdiChildForm.SuspendLayout()
        Dim Font As System.Drawing.FontFamily = New FontFamily(System.Convert.ToString(frmMain.ComboFontStyle.SelectedItem.ToString))
        Try
            If ActiveRichTextBox.SelectionFont IsNot Nothing And ActiveRichTextBox.SelectionFont.Size <> 13 Then
                ActiveRichTextBox.SelectionFont = New Font(Font, ActiveRichTextBox.SelectionFont.Size, ActiveRichTextBox.SelectionFont.Style)
            Else
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
                    ActiveRichTextBox.SelectionFont = New Font(Font, ActiveRichTextBox.SelectionFont.Size, ActiveRichTextBox.SelectionFont.Style)
                    i += 1
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        Catch ex As Exception
            If ex.Message = "未将对象引用设置到对象的实例。" Then
                Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
                Dim FristTextFont As System.Drawing.Font = Nothing, i As Integer = Pos
                Do Until i = Len
                    ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
                    ActiveRichTextBox.SelectionFont = New Font(Font, ActiveRichTextBox.SelectionFont.Size, ActiveRichTextBox.SelectionFont.Style)
                    i += 1
                Loop
                ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len
            End If
        End Try
        ActiveMdiChildForm.ResumeLayout()
        'ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveMdiChildForm = frmMain.ActiveMdiChild
        'ActiveMdiChildForm.SuspendLayout()
        'If frmMain.ComboFontStyle.SelectedIndex <> -1 Then
        '    Dim Font As System.Drawing.FontFamily = New FontFamily(System.Convert.ToString(frmMain.ComboFontStyle.SelectedItem))
        '    If ActiveRichTextBox.SelectionFont IsNot Nothing Then
        '        Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '        Dim currentFontBold As Boolean = ActiveRichTextBox.SelectionFont.Bold, currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic
        '        Dim currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline, currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '        newFontStyle = IIf(currentFontBold, FontStyle.Bold, FontStyle.Regular) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '        IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '        ActiveRichTextBox.SelectionFont = New Font(Font, currentFont.Size, newFontStyle)
        '    Else
        '        Dim Pos As Integer = ActiveRichTextBox.SelectionStart, Len As Integer = ActiveRichTextBox.SelectionLength
        '        Dim currentFontBold As Boolean = frmMain.ButtonBold.Checked
        '        For i As Integer = Pos To Pos + Len - 1
        '            ActiveRichTextBox.SelectionStart = i : ActiveRichTextBox.SelectionLength = 1
        '            Dim currentFont As System.Drawing.Font = ActiveRichTextBox.SelectionFont, newFontStyle As System.Drawing.FontStyle
        '            Dim currentFontItalic As Boolean = ActiveRichTextBox.SelectionFont.Italic, currentFontUnderLine As Boolean = ActiveRichTextBox.SelectionFont.Underline
        '            Dim currentFontStrikoutLine As Boolean = ActiveRichTextBox.SelectionFont.Strikeout
        '            newFontStyle = IIf(currentFontBold, FontStyle.Regular, FontStyle.Bold) Or IIf(currentFontItalic, FontStyle.Italic, FontStyle.Regular) Or _
        '            IIf(currentFontUnderLine, FontStyle.Underline, FontStyle.Regular) Or IIf(currentFontStrikoutLine, FontStyle.Strikeout, FontStyle.Regular)
        '            ActiveRichTextBox.SelectionFont = New Font(Font, currentFont.Size, newFontStyle)
        '        Next
        '        ActiveRichTextBox.SelectionStart = Pos : ActiveRichTextBox.SelectionLength = Len 
        '    End If
        'End If
        'ActiveMdiChildForm.ResumeLayout()
    End Sub

    Public Sub Bullets()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionBullet = Not ActiveRichTextBox.SelectionBullet
    End Sub

    Public Sub SuperScript(ByVal Enabled As Boolean)
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If Enabled = True Then ActiveRichTextBox.SelectionCharOffset = CInt(frmMain.TextBoxSuperScript.Text) Else ActiveRichTextBox.SelectionCharOffset = 0
    End Sub

    Public Sub SubScript(ByVal Enabled As Boolean)
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If Enabled = True Then ActiveRichTextBox.SelectionCharOffset = CInt(frmMain.TextBoxSubScript.Text) Else ActiveRichTextBox.SelectionCharOffset = 0
    End Sub

    Public Sub LeftAlignText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionAlignment = HorizontalAlignment.Left
    End Sub

    Public Sub CenterAlignText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionAlignment = HorizontalAlignment.Center
    End Sub

    Public Sub RightAlignText()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        ActiveRichTextBox.SelectionAlignment = HorizontalAlignment.Right
    End Sub

    Public Sub PageSetting()

    End Sub

    Public Sub PrintFile()

    End Sub

    Public Sub PrintPreview()

    End Sub

    Public Sub InsertImage()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        Dim Image As System.Drawing.Bitmap = Nothing
        With frmMain.OpenFileDialog
            .Filter = ImageDialogFilter
            .RestoreDirectory = True
            If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                Image = System.Drawing.Bitmap.FromFile(.FileName)
            End If
            Dim DataObject As DataObject = New DataObject
            Dim OldDataOnClipboard As DataObject = Clipboard.GetDataObject
            DataObject.SetData(DataFormats.Bitmap, True, Image)
            Clipboard.SetDataObject(DataObject, True)
            Dim Format As DataFormats.Format = DataFormats.GetFormat(DataFormats.Bitmap)
            If ActiveRichTextBox.CanPaste(Format) Then ActiveRichTextBox.Paste(Format)
            Clipboard.SetDataObject(OldDataOnClipboard, True)
        End With
    End Sub

    Public Sub DeleteFileFormDisk()
        ActiveMdiChildForm = frmMain.ActiveMdiChild
        Dim FilePath As String = GetActiveFilePath()
        If FilePath.StartsWith("未命名文件") <> True Then
            Try
                Select Case My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "DelectFileTo", Nothing)
                    Case ModuleMain.DelectFileRecycleBin : My.Computer.FileSystem.DeleteFile(FilePath, FileIO.UIOption.AllDialogs, FileIO.RecycleOption.SendToRecycleBin) : ActiveMdiChildForm.Close()
                    Case ModuleMain.DelectFilePermanently : My.Computer.FileSystem.DeleteFile(FilePath, FileIO.UIOption.AllDialogs, FileIO.RecycleOption.DeletePermanently) : ActiveMdiChildForm.Close()
                    Case Nothing : My.Computer.FileSystem.DeleteFile(FilePath, FileIO.UIOption.AllDialogs, FileIO.RecycleOption.SendToRecycleBin) : ActiveMdiChildForm.Close()
                End Select
            Catch ex As Exception
            End Try
        Else
            MessageBox.Show("必须先保存才能删除文件。", "错误", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Public Sub ShowFontDialog()
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        frmMain.FontDialog.Font = ActiveRichTextBox.SelectionFont
        If frmMain.FontDialog.ShowDialog = System.Windows.Forms.DialogResult.OK Then
            ActiveRichTextBox.SelectionFont = frmMain.FontDialog.Font
            frmMain.ButtonBold.Checked = frmMain.FontDialog.Font.Bold
            frmMain.ButtonItalic.Checked = frmMain.FontDialog.Font.Italic
            frmMain.ButtonUnderLine.Checked = frmMain.FontDialog.Font.Underline
            frmMain.ButtonStrikoutLine.Checked = frmMain.FontDialog.Font.Strikeout
            frmMain.ComboFontStyle.Text = frmMain.FontDialog.Font.Name
            frmMain.ComboFontSize.Text = frmMain.FontDialog.Font.Size
        End If
    End Sub

#End Region

    Public Sub FormatEnabled(ByVal Enabled As Boolean)
        frmMain.RibbonBarFormat.Enabled = Enabled
        frmMain.RibbonBarZoom.Enabled = Enabled
        frmMain.RibbonBarInsert.Enabled = Enabled
    End Sub

    Public Sub ToolBarButtonAndMenuItemEnabled(ByVal Enabled As Boolean)
        frmOptions.chkWordWrap.Enabled = Enabled
        frmMain.TopButtonSave.Enabled = Enabled
        frmMain.TopButtonPrint.Enabled = Enabled
        frmMain.TopButtonUndo.Enabled = Enabled
        frmMain.TopButtonRedo.Enabled = Enabled
        frmMain.StartButtonItemSave.Enabled = Enabled
        frmMain.StartButtonItemSaveAs.Enabled = Enabled
        frmMain.StartButtonItemSaveAll.Enabled = Enabled
        frmMain.StartButtonItemPrint.Enabled = Enabled
        frmMain.StartButtonItemPrintPreview.Enabled = Enabled
        frmMain.StartButtonItemDeleteFileFormDisk.Enabled = Enabled
        frmMain.SliderZoom.Enabled = Enabled
        frmMain.RibbonBarClipardBord.Enabled = Enabled
        frmMain.RibbonBarFormat.Enabled = Enabled
        frmMain.RibbonBarZoom.Enabled = Enabled
        frmMain.RibbonBarInsert.Enabled = Enabled
    End Sub
End Module
