Public Class frmMain

#Region "ť¼"

    Private Sub tsbNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbNew.Click
        ModuleMain.NewDoc()
    End Sub

    Private Sub tsbOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbOpen.Click
        ModuleMain.OpenFile()
    End Sub

    Private Sub tsbSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbSave.Click
        ModuleMain.SaveFile()
    End Sub

    Private Sub tsbSaveAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbSaveAll.Click
        ModuleMain.SaveAllFile()
    End Sub

    Private Sub tsbPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbPrint.Click
        ModuleMain.PrintFile()
    End Sub

    Private Sub tsbPrintPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbPrintPreview.Click
        ModuleMain.PrintPreview()
    End Sub

    Private Sub tsbCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbCut.Click
        ModuleMain.Cut()
    End Sub

    Private Sub tsmiCutAllText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiCutAllText.Click
        ModuleMain.CutAllText()
    End Sub

    Private Sub tsbCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbCopy.Click
        ModuleMain.Copy()
    End Sub

    Private Sub tsmiCopyAllText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiCopyAllText.Click
        ModuleMain.CopyAllText()
    End Sub

    Private Sub tsbPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbPaste.Click
        ModuleMain.Paste()
    End Sub

    Private Sub tsbUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbUndo.Click
        ModuleMain.Undo()
    End Sub

    Private Sub tsbRedo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbRedo.Click
        ModuleMain.Redo()
    End Sub

    Private Sub tsbFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbFind.Click
        frmFindAndReplace.Show()
    End Sub

    Private Sub tsbBold_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbBold.Click
        ModuleMain.Bold()
    End Sub

    Private Sub tsbItalic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbItalic.Click
        ModuleMain.Italic()
    End Sub

    Private Sub tsbUnderLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbUnderLine.Click
        ModuleMain.UnderLine()
    End Sub

    Private Sub tsbStrikoutLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbStrikoutLine.Click
        ModuleMain.StrikoutLine()
    End Sub

    Private Sub tsbLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbLeft.Click
        ModuleMain.LeftAlignText()
        Me.tsbLeft.Checked = True : Me.tsbCenter.Checked = False : Me.tsbRight.Checked = False
    End Sub

    Private Sub tsbCenter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbCenter.Click
        ModuleMain.CenterAlignText()
        Me.tsbLeft.Checked = False : Me.tsbCenter.Checked = True : Me.tsbRight.Checked = False
    End Sub

    Private Sub tsbRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbRight.Click
        ModuleMain.RightAlignText()
        Me.tsbLeft.Checked = False : Me.tsbCenter.Checked = False : Me.tsbRight.Checked = True
    End Sub

    Private Sub tsbBullets_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbBullets.Click
        ModuleMain.Bullets()
    End Sub

    Private Sub tsbSuperScript_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbSuperScript.Click
        ModuleMain.SuperScript(Me.tsbSuperScript.Checked)
        If Me.tsbSuperScript.Checked = False Then Me.tsbSubScript.Enabled = True Else Me.tsbSubScript.Enabled = False
    End Sub

    Private Sub tstxtSuperScript_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tstxtSuperScript.KeyDown
        Try : If e.KeyCode = System.Windows.Forms.Keys.Enter And Me.tstxtSuperScript.Text <> "" Then
                If CInt(Me.tstxtSuperScript.Text) < 0 Or CInt(Me.tstxtSuperScript.Text) > 2000 Then MessageBox.Show("ϱ߾ 0 С 2000", "", MessageBoxButtons.OK, MessageBoxIcon.Error) : Me.tstxtSuperScript.Text = 10
            ElseIf e.KeyCode = System.Windows.Forms.Keys.Enter And (Me.tstxtSuperScript.Text = "" Or Me.tstxtSuperScript.Text = 0) Then : MessageBox.Show("ϱ߾಻Ϊա", "", MessageBoxButtons.OK, MessageBoxIcon.Error) : Me.tstxtSuperScript.Text = 10
            End If
        Catch ex As Exception : Me.tstxtSuperScript.Text = 10
        End Try
    End Sub

    Private Sub tsbSubScript_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbSubScript.Click
        ModuleMain.SubScript(Me.tsbSubScript.Checked)
        If Me.tsbSubScript.Checked = False Then Me.tsbSuperScript.Enabled = True Else Me.tsbSuperScript.Enabled = False
    End Sub

    Private Sub tstxtSubScript_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tstxtSubScript.KeyDown
        Try : If e.KeyCode = System.Windows.Forms.Keys.Enter And Me.tstxtSubScript.Text <> "" Then
                If CInt(Me.tstxtSubScript.Text) < -2000 Or CInt(Me.tstxtSubScript.Text) > 0 Then MessageBox.Show("±߾ -2000 С 0", "", MessageBoxButtons.OK, MessageBoxIcon.Error) : Me.tstxtSubScript.Text = 10
            ElseIf e.KeyCode = System.Windows.Forms.Keys.Enter And (Me.tstxtSubScript.Text = "" Or Me.tstxtSubScript.Text = 0) Then : MessageBox.Show("±߾಻Ϊա", "", MessageBoxButtons.OK, MessageBoxIcon.Error) : Me.tstxtSubScript.Text = 10
            End If
        Catch ex As Exception : Me.tstxtSubScript.Text = -10
        End Try
    End Sub

    Private Sub tsbFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbFont.Click
        ModuleMain.ShowFontDialog()
    End Sub

    Private Sub tsbFontColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbFontColor.Click
        ModuleMain.ShowFontColorDialog()
    End Sub

    Private Sub tsbInsterImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbInsterImage.Click
        ModuleMain.InsertImage()
    End Sub

    Private Sub tsmiZoom25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiZoom25.Click
        ActiveRichTextBox = CType(Me.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.ZoomFactor = 0.25
        Me.tsmiZoom50.Checked = False : Me.tsmiZoom75.Checked = False : Me.tsmiZoom100.Checked = False
        Me.tsmiZoom150.Checked = False : Me.tsmiZoom200.Checked = False : Me.tstxtZoom.Text = 25
    End Sub

    Private Sub tsmiZoom50_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiZoom50.Click
        ActiveRichTextBox = CType(Me.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.ZoomFactor = 0.5
        Me.tsmiZoom25.Checked = False : Me.tsmiZoom75.Checked = False : Me.tsmiZoom100.Checked = False
        Me.tsmiZoom150.Checked = False : Me.tsmiZoom200.Checked = False : Me.tstxtZoom.Text = 50
    End Sub

    Private Sub tsmiZoom75_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiZoom75.Click
        ActiveRichTextBox = CType(Me.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.ZoomFactor = 0.75
        Me.tsmiZoom25.Checked = False : Me.tsmiZoom50.Checked = False : Me.tsmiZoom100.Checked = False
        Me.tsmiZoom150.Checked = False : Me.tsmiZoom200.Checked = False : Me.tstxtZoom.Text = 75
    End Sub

    Private Sub tsmiZoom100_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiZoom100.Click
        ActiveRichTextBox = CType(Me.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.ZoomFactor = 1
        Me.tsmiZoom25.Checked = False : Me.tsmiZoom50.Checked = False : Me.tsmiZoom75.Checked = False
        Me.tsmiZoom150.Checked = False : Me.tsmiZoom200.Checked = False : Me.tstxtZoom.Text = 100
    End Sub

    Private Sub tsmiZoom150_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiZoom150.Click
        ActiveRichTextBox = CType(Me.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.ZoomFactor = 1.5
        Me.tsmiZoom25.Checked = False : Me.tsmiZoom50.Checked = False : Me.tsmiZoom75.Checked = False
        Me.tsmiZoom100.Checked = False : Me.tsmiZoom200.Checked = False : Me.tstxtZoom.Text = 150
    End Sub

    Private Sub tsmiZoom200_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiZoom200.Click
        ActiveRichTextBox = CType(Me.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox) : ActiveRichTextBox.ZoomFactor = 2
        Me.tsmiZoom25.Checked = False : Me.tsmiZoom50.Checked = False : Me.tsmiZoom75.Checked = False
        Me.tsmiZoom100.Checked = False : Me.tsmiZoom150.Checked = False : Me.tstxtZoom.Text = 200
    End Sub

    Private Sub tscmbFontSize_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tscmbFontSize.SelectedIndexChanged
        ModuleMain.ChangeFontSize()
    End Sub

    Private Sub tscmbFontStyle_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tscmbFontStyle.SelectedIndexChanged
        ModuleMain.ChangeFontStyle()
    End Sub

#End Region

#Region "˵¼"

    Private Sub tsmiFileNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFileNew.Click
        ModuleMain.NewDoc()
    End Sub

    Private Sub tsmiFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFileOpen.Click
        ModuleMain.OpenFile()
    End Sub

    Private Sub tsmiFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFileSave.Click
        ModuleMain.SaveFile()
    End Sub

    Private Sub tsmiFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFileSaveAs.Click
        ModuleMain.SaveAsFile()
    End Sub

    Private Sub tsmiFileSaveAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFileSaveAll.Click
        ModuleMain.SaveAllFile()
    End Sub

    Private Sub tsmiFilePageSetting_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFilePageSetting.Click

    End Sub

    Private Sub tsmiFilePrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFilePrint.Click
        ModuleMain.PrintFile()
    End Sub

    Private Sub tsmiFilePrintPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFilePrintPreview.Click
        ModuleMain.PrintPreview()
    End Sub

    Private Sub tsmiFileDeleteFileFormDisk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFileDeleteFileFormDisk.Click
        ModuleMain.DeleteFileFormDisk()
    End Sub

    Private Sub tsmiFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFileExit.Click
        End
    End Sub

    Private Sub tsmiEditUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiEditUndo.Click
        ModuleMain.Undo()
    End Sub

    Private Sub tsmiEditRedo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiEditRedo.Click
        ModuleMain.Redo()
    End Sub

    Private Sub tsmiEditCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiEditCut.Click
        ModuleMain.Cut()
    End Sub

    Private Sub tsmiEditCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiEditCopy.Click
        ModuleMain.Copy()
    End Sub

    Private Sub tsmiEditPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiEditPaste.Click
        ModuleMain.Paste()
    End Sub

    Private Sub tsmiEditFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiEditFind.Click
        frmFindAndReplace.ShowDialog()
    End Sub

    Private Sub tsmiEditAllSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiEditAllSelect.Click
        ModuleMain.SelectAll()
    End Sub

    Private Sub tsmiViewMainToolBar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiViewMainToolBar.Click
        tsrMain.Visible = Me.tsmiViewMainToolBar.Checked
    End Sub

    Private Sub tsmiViewFormat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiViewFormat.Click
        tsrFormat.Visible = Me.tsmiViewFormat.Checked
    End Sub

    Private Sub tsmiViewStatusBar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiViewStatusBar.Click
        ssrMain.Visible = Me.tsmiViewStatusBar.Checked
    End Sub

    Private Sub tsmiFormatFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFormatFont.Click
        ModuleMain.ShowFontDialog()
    End Sub

    Private Sub tsmiFormatFontColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFormatFontColor.Click
        ModuleMain.ShowFontColorDialog()
    End Sub

    Private Sub tsmiFormatInsterImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFormatInsterImage.Click
        ModuleMain.InsertImage()
    End Sub

    Private Sub tsmiFormatBold_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFormatBold.Click
        ModuleMain.Bold()
        Me.tsbBold.Checked = Me.tsmiFormatBold.Checked
    End Sub

    Private Sub tsmiFormatItalic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFormatItalic.Click
        ModuleMain.Italic()
        Me.tsbItalic.Checked = Me.tsmiFormatItalic.Checked
    End Sub

    Private Sub tsmiFormatUnderLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFormatUnderLine.Click
        ModuleMain.UnderLine()
        Me.tsbUnderLine.Checked = Me.tsmiFormatUnderLine.Checked
    End Sub

    Private Sub tsmiFormatStrikoutLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFormatStrikoutLine.Click
        ModuleMain.StrikoutLine()
        Me.tsbStrikoutLine.Checked = Me.tsmiFormatStrikoutLine.Checked
    End Sub

    Private Sub tsmiToolOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiToolOptions.Click
        frmOptions.ShowDialog()
    End Sub

    Private Sub tsmiHelpAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiHelpAbout.Click
        frmAbout.ShowDialog()
    End Sub

#End Region

    Private Sub tmrMain_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrMain.Tick
        With frmDoc
            If .rtxMain.SelectedText <> "" Then
                Me.tsbCut.Enabled = False : Me.tsbCopy.Enabled = False
            Else
                Me.tsbCut.Enabled = True : Me.tsbCopy.Enabled = True
            End If
            If Clipboard.GetDataObject.GetDataPresent(DataFormats.Text) = False Then Me.tsbPaste.Enabled = False
            If .rtxMain.CanUndo = True Then Me.tsbUndo.Enabled = True Else Me.tsbRedo.Enabled = False
            If .rtxMain.CanRedo = True Then Me.tsbRedo.Enabled = True Else Me.tsbRedo.Enabled = False
        End With
    End Sub

    Private Sub tmrChangeStatusText_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrChangeStatusText.Tick
        Me.tslblStatus.Text = ""
        Me.tmrChangeStatusText.Enabled = False
    End Sub

    Private Sub tmrTimeAndDate_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrTimeAndDate.Tick
        Me.tslblTimeAndDate.Text = Now
    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormSize", "Width", Me.Size.Width, Microsoft.Win32.RegistryValueKind.DWord)
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormSize", "Height", Me.Size.Height, Microsoft.Win32.RegistryValueKind.DWord)
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormLocation", "X", Me.Location.X, Microsoft.Win32.RegistryValueKind.DWord)
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormLocation", "Y", Me.Location.Y, Microsoft.Win32.RegistryValueKind.DWord)
        Select Case Me.WindowState
            Case System.Windows.Forms.FormWindowState.Normal
                My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit", "FormState", 0)
            Case System.Windows.Forms.FormWindowState.Minimized
                My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit", "FormState", 1)
            Case System.Windows.Forms.FormWindowState.Maximized
                My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit", "FormState", 2)
        End Select
    End Sub
    Private RenameFileOrDirOldName As String, IsShowVolumeLabel As Boolean, OpenFileStyle As String, ActiveRichTextBox As System.Windows.Forms.RichTextBox
    Private Sub tvwFile_BeforeLabelEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs) Handles tvwFile.BeforeLabelEdit
        If e.Node.Name <> "Disk" And IsShowVolumeLabel = True Then
            RenameFileOrDirOldName = DeleteVolumeLabel(e.Node.FullPath, False)
        ElseIf e.Node.Name <> "Disk" And IsShowVolumeLabel = False Then
            RenameFileOrDirOldName = e.Node.FullPath
        Else
            e.CancelEdit = True
        End If
    End Sub

    Private Sub tvwFile_AfterLabelEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs) Handles tvwFile.AfterLabelEdit
        If e.Node.Name = "Folder" AndAlso e.Label <> Nothing AndAlso e.Label.IndexOfAny(New Char() {"\", "/", ":", "*", "?", """", "<", ">", "|"}) = -1 Then
            My.Computer.FileSystem.RenameDirectory(RenameFileOrDirOldName, e.Label)
        ElseIf e.Node.Name = "File" AndAlso e.Label <> Nothing AndAlso e.Label.IndexOfAny(New Char() {"\", "/", ":", "*", "?", """", "<", ">", "|"}) = -1 Then
            My.Computer.FileSystem.RenameFile(RenameFileOrDirOldName, e.Label)
        ElseIf e.Label <> Nothing AndAlso e.Label.IndexOfAny(New Char() {"\", "/", ":", "*", "?", """", "<", ">", "|"}) <> -1 Then
            MessageBox.Show("ļļַܰ  \ , / , : , * , ? , "" , < , > , |", "", MessageBoxButtons.OK, MessageBoxIcon.Error) : e.CancelEdit = True
        End If
    End Sub

    Private Sub tvwFile_NodeMouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles tvwFile.NodeMouseDoubleClick
        Try
            Dim Exception() As String = CStr(My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyleException", Nothing)).Split("||"), Number As Integer
            If My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyleException", Nothing) <> "NoException" Then
                If e.Node.Name = "File" And IsShowVolumeLabel = True Then
                    If OpenFileStyle = ModuleMain.FileOpenStyleIntegration Then : OpenFile(DeleteVolumeLabel(e.Node.FullPath, False))
                    ElseIf OpenFileStyle = ModuleMain.FileOpenStyleExternalExceptionUseIntegeration Then
                        For Each i As String In Exception
                            If e.Node.FullPath.EndsWith(i) = True And i <> "" Then : OpenFile(DeleteVolumeLabel(e.Node.FullPath, False)) : Exit For
                            ElseIf e.Node.FullPath.EndsWith(i) = False And Number = Exception.Length - 1 Then : System.Diagnostics.Process.Start(DeleteVolumeLabel(e.Node.FullPath, False)) : Exit For
                            End If : Number += 1
                        Next
                    ElseIf OpenFileStyle = ModuleMain.FileOpenStyleExternalExceptionUseExternal Then : System.Diagnostics.Process.Start(DeleteVolumeLabel(e.Node.FullPath, False))
                    End If
                ElseIf e.Node.Name = "File" And IsShowVolumeLabel = False Then
                    If OpenFileStyle = ModuleMain.FileOpenStyleIntegration Then : OpenFile(e.Node.FullPath)
                    ElseIf OpenFileStyle = ModuleMain.FileOpenStyleExternalExceptionUseIntegeration Then
                        For Each i As String In Exception
                            If e.Node.FullPath.EndsWith(i) = True And i <> "" Then : OpenFile(e.Node.FullPath) : Exit For
                            ElseIf e.Node.FullPath.EndsWith(i) = False And Number = Exception.Length - 1 Then : System.Diagnostics.Process.Start(e.Node.FullPath) : Exit For
                            End If : Number += 1
                        Next
                    ElseIf OpenFileStyle = ModuleMain.FileOpenStyleExternalExceptionUseExternal Then : System.Diagnostics.Process.Start(e.Node.FullPath, False)
                    End If
                End If
            Else
                If IsShowVolumeLabel = True Then
                    If OpenFileStyle = ModuleMain.FileOpenStyleIntegration And IsShowVolumeLabel = True Then : OpenFile(DeleteVolumeLabel(e.Node.FullPath, False))
                    Else : System.Diagnostics.Process.Start(DeleteVolumeLabel(e.Node.FullPath, False))
                    End If
                ElseIf IsShowVolumeLabel = False Then
                    If OpenFileStyle = ModuleMain.FileOpenStyleIntegration And IsShowVolumeLabel = True Then : OpenFile(e.Node.FullPath)
                    Else : System.Diagnostics.Process.Start(e.Node.FullPath)
                    End If
                End If
            End If
        Catch ex As Exception
            If ex.Message = "ûӦó˲ָļй" Then
                Dim Res As System.Windows.Forms.DialogResult = MessageBox.Show("ļ " & e.Node.Text & " ûĬϵĴ򿪷ʽ,Ƿʹü±?", "", MessageBoxButtons.YesNo, MessageBoxIcon.Warning)
                If Res = System.Windows.Forms.DialogResult.Yes And IsShowVolumeLabel = True Then
                    System.Diagnostics.Process.Start("notepad.exe", DeleteVolumeLabel(e.Node.FullPath, False))
                ElseIf Res = Windows.Forms.DialogResult.Yes And IsShowVolumeLabel = False Then
                    System.Diagnostics.Process.Start("notepad.exe", e.Node.FullPath)
                End If
            End If
        End Try
    End Sub

    Private Sub tvwFile_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvwFile.AfterSelect
        If e.Node.Nodes.Count = 0 And IsShowVolumeLabel = True Then
            If e.Node.Name = "Disk" Then
                Dim FormatText As String = DeleteVolumeLabel(e.Node.Text, True), DriveInfo As System.IO.DriveInfo = My.Computer.FileSystem.GetDriveInfo(FormatText)
                If DriveInfo.IsReady = True Then Me.tvwFile.BeginUpdate() : LoadFolderAndFile(e.Node, DriveInfo.RootDirectory) : Me.tvwFile.EndUpdate()
            ElseIf e.Node.Name = "Folder" Then
                Me.tvwFile.BeginUpdate() : LoadFolderAndFile(e.Node, My.Computer.FileSystem.GetDirectoryInfo(DeleteVolumeLabel(e.Node.FullPath, False))) : Me.tvwFile.EndUpdate()
            End If
        ElseIf e.Node.Nodes.Count = 0 And IsShowVolumeLabel = False Then
            If e.Node.Name = "Disk" Then
                Dim DriveInfo As System.IO.DriveInfo = My.Computer.FileSystem.GetDriveInfo(e.Node.Text)
                If DriveInfo.IsReady = True Then Me.tvwFile.BeginUpdate() : LoadFolderAndFile(e.Node, DriveInfo.RootDirectory) : Me.tvwFile.EndUpdate()
            ElseIf e.Node.Name = "Folder" Then
                Me.tvwFile.BeginUpdate() : LoadFolderAndFile(e.Node, My.Computer.FileSystem.GetDirectoryInfo(e.Node.FullPath)) : Me.tvwFile.EndUpdate()
            End If
        End If
    End Sub

    Public Function DeleteVolumeLabel(ByVal FormatText As String, ByVal IsDiskPath As Boolean) As String
        Dim Text() As String = FormatText.Split(New Char() {"(", ")"})
        For Each Find As String In Text
            If IsDiskPath = True Then : If Find.Contains(":") = True Then Return Find
            ElseIf IsDiskPath = False Then
                If Find.Contains(":") = True Then
                    If FormatText.Contains("(") OrElse FormatText.Contains(")") = True And IsDiskPath = True Then
                        Dim FormatTextSplit() As String = FormatText.Split("\"), i As Integer
                        Dim CutBracketText() As String, DiskName As String = Nothing
                        Dim FolderPath(FormatTextSplit.Length) As String, Res As String = Nothing, Number As Integer
                        For Each FormatTextSplitItem As String In FormatTextSplit
                            If i = 0 Then : CutBracketText = FormatTextSplitItem.Split(New Char() {"(", ")"})
                                For Each Item As String In CutBracketText
                                    If Item.Contains(":") = True Then DiskName = Item
                                Next
                            End If : i += 1
                        Next
                        For Each Item As String In FormatTextSplit
                            If Number <> 0 Then If Number = FormatTextSplit.Length - 1 Then Res &= "\" & Item Else Res &= "\" & Item & "\"
                            Number += 1
                        Next
                        Return DiskName & Res
                    End If
                End If
            End If
        Next
        Return Nothing
    End Function

    Public Sub LoadFolderAndFile(ByVal ParentNode As System.Windows.Forms.TreeNode, ByVal FolderInfo As System.IO.DirectoryInfo)
        Dim ActiveFileNode As System.Windows.Forms.TreeNode, ActiveFileInfo As System.IO.FileInfo, ActiveFolderInfo As System.IO.DirectoryInfo, ActiveFolderNodes As System.Windows.Forms.TreeNode
        If IsShowVolumeLabel = True Then
            If FolderInfo.Parent Is Nothing Then
                For Each Folder As String In My.Computer.FileSystem.GetDirectories(DeleteVolumeLabel(FolderInfo.FullName, True))
                    ActiveFolderNodes = ParentNode.Nodes.Add("Folder", My.Computer.FileSystem.GetDirectoryInfo(Folder).Name, "ShutFolder", "OpenFolder")
                    ActiveFolderInfo = My.Computer.FileSystem.GetDirectoryInfo(DeleteVolumeLabel(ActiveFolderNodes.FullPath, False))
                    ActiveFolderNodes.ToolTipText = ActiveFolderInfo.FullName & vbCrLf & "޸:" & ActiveFolderInfo.LastWriteTime.ToString & vbCrLf & ":" & ActiveFolderInfo.CreationTime.ToString
                Next
                For Each File As String In My.Computer.FileSystem.GetFiles(DeleteVolumeLabel(FolderInfo.ToString, True))
                    ActiveFileNode = ParentNode.Nodes.Add("File", My.Computer.FileSystem.GetFileInfo(File).Name, "File", "File")
                    ActiveFileInfo = My.Computer.FileSystem.GetFileInfo(DeleteVolumeLabel(ActiveFileNode.FullPath, False))
                    ActiveFileNode.ToolTipText = DeleteVolumeLabel(ActiveFileNode.FullPath, False) & vbCrLf & "ļС:" & CSng(ActiveFileInfo.Length / 1024) & "KB" & vbCrLf & "޸:" & ActiveFileInfo.LastWriteTime.ToString & vbCrLf & ":" & ActiveFileInfo.CreationTime.ToString
                Next
            ElseIf FolderInfo.Parent IsNot Nothing Then
                For Each Folder As String In My.Computer.FileSystem.GetDirectories(FolderInfo.FullName)
                    ActiveFolderNodes = ParentNode.Nodes.Add("Folder", My.Computer.FileSystem.GetDirectoryInfo(Folder).Name, "ShutFolder", "OpenFolder")
                    ActiveFolderInfo = My.Computer.FileSystem.GetDirectoryInfo(DeleteVolumeLabel(ActiveFolderNodes.FullPath, False))
                    ActiveFolderNodes.ToolTipText = ActiveFolderInfo.FullName & vbCrLf & "޸:" & ActiveFolderInfo.LastWriteTime.ToString & vbCrLf & ":" & ActiveFolderInfo.CreationTime.ToString
                Next
                For Each File As String In My.Computer.FileSystem.GetFiles(FolderInfo.ToString)
                    ActiveFileNode = ParentNode.Nodes.Add("File", My.Computer.FileSystem.GetFileInfo(File).Name, "File", "File")
                    ActiveFileInfo = My.Computer.FileSystem.GetFileInfo(DeleteVolumeLabel(ActiveFileNode.FullPath, False))
                    ActiveFileNode.ToolTipText = DeleteVolumeLabel(ActiveFileNode.FullPath, False) & vbCrLf & "ļС:" & CSng(ActiveFileInfo.Length / 1024) & "KB" & vbCrLf & "޸:" & ActiveFileInfo.LastWriteTime.ToString & vbCrLf & ":" & ActiveFileInfo.CreationTime.ToString
                Next
            End If
        Else
            For Each Folder As String In My.Computer.FileSystem.GetDirectories(FolderInfo.FullName)
                ActiveFolderNodes = ParentNode.Nodes.Add("Folder", My.Computer.FileSystem.GetDirectoryInfo(Folder).Name, "ShutFolder", "OpenFolder")
                ActiveFolderInfo = My.Computer.FileSystem.GetDirectoryInfo(ActiveFolderNodes.FullPath)
                ActiveFolderNodes.ToolTipText = ActiveFolderInfo.FullName & vbCrLf & "޸:" & ActiveFolderInfo.LastWriteTime.ToString & vbCrLf & ":" & ActiveFolderInfo.CreationTime.ToString
            Next
            For Each File As String In My.Computer.FileSystem.GetFiles(FolderInfo.ToString)
                ActiveFileNode = ParentNode.Nodes.Add("File", My.Computer.FileSystem.GetFileInfo(File).Name, "File", "File")
                ActiveFileInfo = My.Computer.FileSystem.GetFileInfo(ActiveFileNode.FullPath)
                ActiveFileNode.ToolTipText = ActiveFileNode.FullPath & vbCrLf & "ļС:" & CSng(ActiveFileInfo.Length / 1024) & "KB" & vbCrLf & "޸:" & ActiveFileInfo.LastWriteTime.ToString & vbCrLf & ":" & ActiveFileInfo.CreationTime.ToString
            Next
        End If
    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim AllFonts As System.Drawing.FontFamily
        Me.Text = "СС༭ V" & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & "." & My.Application.Info.Version.Revision
        Me.tslblUserName.Text = "\û:" & My.User.Name
        For Each AllFonts In System.Drawing.FontFamily.Families
            Me.tscmbFontStyle.Items.Add(AllFonts.Name)
        Next
        Dim Driver As System.IO.DriveInfo
        Me.tvwFile.BeginUpdate()
        For Each Driver In My.Computer.FileSystem.Drives
            Dim ActiveNode As System.Windows.Forms.TreeNode = Nothing, ActiveDiskInfo As System.IO.DriveInfo
            Select Case Driver.DriveType
                Case System.IO.DriveType.Fixed
                    ActiveDiskInfo = My.Computer.FileSystem.GetDriveInfo(Driver.ToString)
                    Select Case My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Nothing)
                        Case True : ActiveNode = Me.tvwFile.Nodes.Add("Disk", ActiveDiskInfo.VolumeLabel & " (" & Driver.ToString.Replace("\", Nothing) & ")", "HardDisk", "HardDisk")
                        Case False : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "HardDisk", "HardDisk")
                        Case Nothing : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "HardDisk", "HardDisk")
                    End Select
                    If ActiveDiskInfo.IsReady = True Then ActiveNode.ToolTipText = ActiveNode.Text & vbCrLf & "ļϵͳ:" & ActiveDiskInfo.DriveFormat & vbCrLf & "ÿռ:" & CSng(ActiveDiskInfo.TotalFreeSpace) / 1024 / 1024 / 1024 & "GB" & vbCrLf & "ܿռ:" & CSng(ActiveDiskInfo.TotalSize) / 1024 / 1024 / 1024 & "GB"
                Case System.IO.DriveType.CDRom
                    ActiveDiskInfo = My.Computer.FileSystem.GetDriveInfo(Driver.ToString)
                    Select Case My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Nothing)
                        Case True : If ActiveDiskInfo.IsReady = True Then ActiveNode = Me.tvwFile.Nodes.Add("Disk", ActiveDiskInfo.VolumeLabel & " (" & Driver.ToString.Replace("\", Nothing) & ")", "CDDisk", "CDDisk") Else ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "CDDisk", "CDDisk")
                        Case False : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "CDDisk", "CDDisk")
                        Case Nothing : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "CDDisk", "CDDisk")
                    End Select
                    If ActiveDiskInfo.IsReady = True Then ActiveNode.ToolTipText = ActiveNode.Text & vbCrLf & "ļϵͳ:" & ActiveDiskInfo.DriveFormat & vbCrLf & "ÿռ:" & CSng(ActiveDiskInfo.TotalFreeSpace) / 1024 / 1024 & "MB" & vbCrLf & "ܿռ:" & CSng(ActiveDiskInfo.TotalSize) / 1024 / 1024 & "MB"
                Case System.IO.DriveType.Removable
                    ActiveDiskInfo = My.Computer.FileSystem.GetDriveInfo(Driver.ToString)
                    Select Case My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Nothing)
                        Case True : ActiveNode = Me.tvwFile.Nodes.Add("Disk", ActiveDiskInfo.VolumeLabel & " (" & Driver.ToString.Replace("\", Nothing) & ")", "RemoveableDisk", "RemoveableDisk")
                        Case False : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "RemoveableDisk", "RemoveableDisk")
                        Case Nothing : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "RemoveableDisk", "RemoveableDisk")
                    End Select
                    If ActiveDiskInfo.IsReady = True Then ActiveNode.ToolTipText = ActiveNode.Text & vbCrLf & "ļϵͳ:" & ActiveDiskInfo.DriveFormat & vbCrLf & "ÿռ:" & CSng(ActiveDiskInfo.TotalFreeSpace) / 1024 / 1024 / 1024 & "GB" & vbCrLf & "ܿռ:" & CSng(ActiveDiskInfo.TotalSize) / 1024 / 1024 / 1024 & "GB"
                Case System.IO.DriveType.Network
                    ActiveDiskInfo = My.Computer.FileSystem.GetDriveInfo(Driver.ToString)
                    Select Case My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Nothing)
                        Case True : ActiveNode = Me.tvwFile.Nodes.Add("Disk", ActiveDiskInfo.VolumeLabel & " (" & Driver.ToString.Replace("\", Nothing) & ")", "WebDisk", "WebDisk")
                        Case False : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "WebDisk", "WebDisk")
                        Case Nothing : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "WebDisk", "WebDisk")
                    End Select
                    If ActiveDiskInfo.IsReady = True Then ActiveNode.ToolTipText = ActiveNode.Text & vbCrLf & "ļϵͳ:" & ActiveDiskInfo.DriveFormat & vbCrLf & "ÿռ:" & CSng(ActiveDiskInfo.TotalFreeSpace) / 1024 / 1024 & "MB" & vbCrLf & "ܿռ:" & CSng(ActiveDiskInfo.TotalSize) / 1024 / 1024 & "MB"
                Case System.IO.DriveType.Unknown
                    ActiveDiskInfo = My.Computer.FileSystem.GetDriveInfo(Driver.ToString)
                    Select Case My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Nothing)
                        Case True : ActiveNode = Me.tvwFile.Nodes.Add("Disk", ActiveDiskInfo.VolumeLabel & " (" & Driver.ToString.Replace("\", Nothing) & ")", "HardDisk", "HardDisk")
                        Case False : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "HardDisk", "HardDisk")
                        Case Nothing : ActiveNode = Me.tvwFile.Nodes.Add("Disk", Driver.ToString.Replace("\", Nothing), "HardDisk", "HardDisk")
                    End Select
                    If ActiveDiskInfo.IsReady = True Then ActiveNode.ToolTipText = ActiveNode.Text & vbCrLf & "ļϵͳ:" & ActiveDiskInfo.DriveFormat & vbCrLf & "ÿռ:" & CSng(ActiveDiskInfo.TotalFreeSpace) / 1024 / 1024 / 1024 & "GB" & vbCrLf & "ܿռ:" & CSng(ActiveDiskInfo.TotalSize) / 1024 / 1024 / 1024 & "GB"
            End Select
        Next
        Me.tvwFile.EndUpdate()
        ModuleMain.ToolBarButtonAndMenuItemEnabled(False)
        Dim FormSize As System.Drawing.Size, FormLocation As System.Drawing.Point
        Me.WindowState = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit", "FormState", Me.WindowState)
        If My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit", "IsFristRun", Nothing) <> Nothing Then
            FormLocation.X = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormLocation", "X", Me.Location.X)
            FormLocation.Y = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormLocation", "Y", Me.Location.Y)
            FormSize.Width = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormSize", "Width", Me.Size.Width)
            FormSize.Height = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\FormSize", "Height", Me.Size.Height)
            Me.Location = FormLocation : Me.Size = FormSize
        Else
            Me.StartPosition = FormStartPosition.CenterScreen : Me.Size = New System.Drawing.Size(933, 548)
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit", "IsFirstRun", "0", Microsoft.Win32.RegistryValueKind.DWord)
        End If
        Dim TopMostForm As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "TopMostForm", Nothing)
        Dim WordWrap As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "WordWrap", Nothing)
        Dim Style As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "Style", Nothing)
        Dim NewFileWhenStart As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "NewFileWhenStart", Nothing)
        Dim RibbonStyle As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "RibbonStyle", Nothing)
        Dim FileIconStyle As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileIconStyle", Nothing)
        Dim FileVolumeLabel As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Nothing)
        Dim FileOpenStyle As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyle", Nothing)
        If TopMostForm <> Nothing Or WordWrap <> Nothing Or NewFileWhenStart <> Nothing Or RibbonStyle <> Nothing Or FileVolumeLabel <> Nothing Or FileOpenStyle <> Nothing Then
            IsShowVolumeLabel = FileVolumeLabel
            If My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "Style", Nothing) = ModuleMain.StyleRibbon Then
                System.Diagnostics.Process.Start(My.Application.Info.DirectoryPath & "\SmallEdit_Ribbon.exe") : End
            End If
            Select Case FileIconStyle
                Case ModuleMain.FileIconStyleXP : Me.tvwFile.ImageList = Me.imgFileXP
                Case ModuleMain.FileIconStyleClassic : Me.tvwFile.ImageList = Me.imgFileClassic
            End Select
            Select Case FileOpenStyle
                Case ModuleMain.FileOpenStyleIntegration : OpenFileStyle = ModuleMain.FileOpenStyleIntegration
                Case ModuleMain.FileOpenStyleExternalExceptionUseExternal : OpenFileStyle = ModuleMain.FileOpenStyleExternalExceptionUseExternal
                Case ModuleMain.FileOpenStyleExternalExceptionUseIntegeration : OpenFileStyle = ModuleMain.FileOpenStyleExternalExceptionUseIntegeration
            End Select
            If NewFileWhenStart = "True" Then ModuleMain.NewDoc() : ModuleMain.ToolBarButtonAndMenuItemEnabled(True)
            Me.TopMost = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "TopMostForm", Nothing)
            frmOptions.TopMost = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "TopMostForm", Nothing)
            ModuleMain.NewForm.rtxMain.WordWrap = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "WordWrap", Nothing)
        Else
            Me.TopMost = False : ModuleMain.NewForm.rtxMain.WordWrap = False
        End If
    End Sub

    Private Sub tmrKeysStatus_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrKeysStatus.Tick
        If GetKeyState(System.Windows.Forms.Keys.CapsLock) = KEYSTATUS_KEYUP Then : CaspLockKeyStatus = False : Me.tslblCapsLock.ForeColor = Color.Gray
        ElseIf GetKeyState(System.Windows.Forms.Keys.CapsLock) = KEYSTATUS_KEYDOWN Then : CaspLockKeyStatus = True : Me.tslblCapsLock.ForeColor = Color.Black : End If
        If GetKeyState(System.Windows.Forms.Keys.NumLock) = KEYSTATUS_KEYUP Then : NumLockKeyStatus = False : Me.tslblNumber.ForeColor = Color.Gray
        ElseIf GetKeyState(System.Windows.Forms.Keys.NumLock) = KEYSTATUS_KEYDOWN Then : NumLockKeyStatus = True : Me.tslblNumber.ForeColor = Color.Black : End If
        If GetKeyState(System.Windows.Forms.Keys.Insert) = KEYSTATUS_KEYUP Then : InsertKeyStatus = False : Me.tslblInsert.ForeColor = Color.Gray
        ElseIf GetKeyState(System.Windows.Forms.Keys.Insert) = KEYSTATUS_KEYDOWN Then : InsertKeyStatus = True : Me.tslblInsert.ForeColor = Color.Black : End If
    End Sub

    Private Sub tslblCapsLock_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles tslblCapsLock.Click
        If CaspLockKeyStatus = False Then
            keybd_event(System.Windows.Forms.Keys.CapsLock, 0, 0, 0)
            keybd_event(System.Windows.Forms.Keys.CapsLock, 0, 2, 0)
            Me.tslblCapsLock.ForeColor = Color.Black
        ElseIf CaspLockKeyStatus = True Then
            keybd_event(System.Windows.Forms.Keys.CapsLock, 0, 0, 0)
            keybd_event(System.Windows.Forms.Keys.CapsLock, 0, 2, 0)
            Me.tslblCapsLock.ForeColor = Color.Gray
        End If
    End Sub

    Private Sub tslblNumber_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles tslblNumber.Click
        If NumLockKeyStatus = False Then
            keybd_event(System.Windows.Forms.Keys.NumLock, 0, 0, 0)
            keybd_event(System.Windows.Forms.Keys.NumLock, 0, 2, 0)
            Me.tslblNumber.ForeColor = Color.Black
        ElseIf NumLockKeyStatus = True Then
            keybd_event(System.Windows.Forms.Keys.NumLock, 0, 0, 0)
            keybd_event(System.Windows.Forms.Keys.NumLock, 0, 2, 0)
            Me.tslblNumber.ForeColor = Color.Gray
        End If
    End Sub

    Private Sub tslblInsert_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles tslblInsert.Click
        If InsertKeyStatus = False Then
            keybd_event(System.Windows.Forms.Keys.Insert, 0, 0, 0)
            keybd_event(System.Windows.Forms.Keys.Insert, 0, 2, 0)
            Me.tslblInsert.ForeColor = Color.Black
        ElseIf InsertKeyStatus = True Then
            keybd_event(System.Windows.Forms.Keys.Insert, 0, 0, 0)
            keybd_event(System.Windows.Forms.Keys.Insert, 0, 2, 0)
            Me.tslblInsert.ForeColor = Color.Gray
        End If
    End Sub

    Private Sub tstxtZoom_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tstxtZoom.KeyUp
        ActiveRichTextBox = CType(Me.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        Try : If e.KeyCode = System.Windows.Forms.Keys.Enter Then
                Dim ZoomNumber As Single = CSng(Me.tstxtZoom.Text)
                If ZoomNumber < 6400 And ZoomNumber > 1.5625 Then : ActiveRichTextBox.ZoomFactor = ZoomNumber / 100
                    Me.tsmiZoom25.Checked = False : Me.tsmiZoom50.Checked = False : Me.tsmiZoom75.Checked = False
                    Me.tsmiZoom100.Checked = False : Me.tsmiZoom150.Checked = False : Me.tsmiZoom200.Checked = False
                Else : MessageBox.Show("ű 1.5625% С 6400%", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
        Catch ex As Exception : Me.tstxtZoom.Text = 100
        End Try
    End Sub
End Class
