﻿Public Class frmOptions

    Private Sub btnAccept_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAccept.Click
        Me.TopMost = Me.chkTopMostForm.Checked : frmMain.TopMost = Me.chkTopMostForm.Checked
        For Each i As System.Windows.Forms.Form In frmMain.MdiChildren
            CType(i.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox).WordWrap = Me.chkWordWrap.Checked
        Next
        frmMain.Opacity = Me.trbOpacity.Value / 100
        If Me.rdoStyleOffice2003.Checked = True Then
            MessageBox.Show("更改样式将在下一次启动时生效。", "警告", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "Style", ModuleMain.StyleOffice2003, Microsoft.Win32.RegistryValueKind.String)
        ElseIf Me.rdoStyleRibbon.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "Style", ModuleMain.StyleRibbon, Microsoft.Win32.RegistryValueKind.String)
        End If
        If Me.rdoDelectFileRecycleBin.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "DelectFileTo", ModuleMain.DelectFileRecycleBin, Microsoft.Win32.RegistryValueKind.String)
        ElseIf Me.rdoDelectFilePermanently.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "DelectFileTo", ModuleMain.DelectFilePermanently, Microsoft.Win32.RegistryValueKind.String)
        End If
        If Me.rdoFileIconStyleXP.Checked = True Then
            frmMain.tvwFile.ImageList = frmMain.imgFileXP
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileIconStyle", ModuleMain.FileIconStyleXP, Microsoft.Win32.RegistryValueKind.String)
        ElseIf Me.rdoFileIconStyleClassic.Checked = True Then
            frmMain.tvwFile.ImageList = frmMain.imgFileClassic
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileIconStyle", ModuleMain.FileIconStyleClassic, Microsoft.Win32.RegistryValueKind.String)
        End If
        If Me.rdoFileIntegration.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyle", ModuleMain.FileOpenStyleIntegration, Microsoft.Win32.RegistryValueKind.String)
        ElseIf Me.rdoFileExternalRtfUseIntegeration.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyle", ModuleMain.FileOpenStyleExternalExceptionUseIntegeration, Microsoft.Win32.RegistryValueKind.String)
        ElseIf Me.rdoFileExternalRtfUseExternal.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyle", ModuleMain.FileOpenStyleExternalExceptionUseExternal, Microsoft.Win32.RegistryValueKind.String)
        End If
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Me.chkFileVolumeLabel.Checked, Microsoft.Win32.RegistryValueKind.String)
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileToopTips", Me.chkFileToopTips.Checked, Microsoft.Win32.RegistryValueKind.String)
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "NewFileWhenStart", Me.chkNewFileWhenStart.Checked, Microsoft.Win32.RegistryValueKind.String)
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "TopMostForm", Me.chkTopMostForm.Checked, Microsoft.Win32.RegistryValueKind.String)
        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "WordWrap", Me.chkWordWrap.Checked, Microsoft.Win32.RegistryValueKind.String)
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub

    Private Sub trbOpacity_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trbOpacity.Scroll
        Me.lblOpacity.Text = "透明度:" & Me.trbOpacity.Value & "%"
        If Me.lblOpacity.Text = "透明度:100%" Then Me.lblOpacity.Text += "(不透明)"
    End Sub

    Private Sub frmOptions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim TopMostForm As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "TopMostForm", Nothing)
        Dim WordWrap As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "WordWrap", Nothing)
        Dim Style As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "Style", Nothing)
        Dim NewFileWhenStart As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "NewFileWhenStart", Nothing)
        Dim DelectFileTo As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "DelectFileTo", Nothing)
        Dim FileToopTips As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileToopTips", Nothing)
        Dim FileIconStyle As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileIconStyle", Nothing)
        Dim FileVolumeLabel As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileVolumeLabel", Nothing)
        Dim FileOpenStyle As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyle", Nothing)
        Dim FileOpenStyleException As String = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyleException", Nothing)
        Dim FileShowHiddenFile As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileShowHiddenFile", Nothing)
        Dim FileShowSystemFile As Boolean = My.Computer.Registry.GetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileShowSystemFile", Nothing)
        If TopMostForm <> Nothing Or WordWrap <> Nothing Or NewFileWhenStart <> Nothing Or DelectFileTo <> Nothing Or _
            FileToopTips <> Nothing Or FileIconStyle <> Nothing Or FileVolumeLabel <> Nothing Or FileOpenStyle <> Nothing Or _
            FileOpenStyleException <> Nothing Or FileShowHiddenFile <> Nothing Or FileShowSystemFile <> Nothing Then
            Dim ExceptionList() As String = FileOpenStyleException.Split("||")
            Me.chkTopMostForm.Checked = TopMostForm : Me.chkWordWrap.Checked = WordWrap : Me.chkNewFileWhenStart.Checked = NewFileWhenStart
            Me.chkFileVolumeLabel.Checked = FileVolumeLabel : Me.chkFileToopTips.Checked = FileToopTips
            Select Case Style
                Case ModuleMain.StyleOffice2003 : Me.rdoStyleOffice2003.Checked = True
                Case ModuleMain.StyleRibbon : Me.rdoStyleRibbon.Checked = True
                Case Nothing : Me.rdoStyleOffice2003.Checked = False : Me.rdoStyleRibbon.Checked = False
            End Select
            Select Case DelectFileTo
                Case ModuleMain.DelectFileRecycleBin : Me.rdoDelectFileRecycleBin.Checked = True
                Case ModuleMain.DelectFilePermanently : Me.rdoDelectFilePermanently.Checked = True
                Case Nothing : Me.rdoDelectFileRecycleBin.Checked = False : Me.rdoDelectFilePermanently.Checked = False
            End Select
            Select Case FileIconStyle
                Case ModuleMain.FileIconStyleXP : Me.rdoFileIconStyleXP.Checked = True
                Case ModuleMain.FileIconStyleClassic : Me.rdoFileIconStyleClassic.Checked = True
            End Select
            Select Case FileOpenStyle
                Case ModuleMain.FileOpenStyleIntegration : Me.rdoFileIntegration.Checked = True
                Case ModuleMain.FileOpenStyleExternalExceptionUseIntegeration : Me.rdoFileExternalRtfUseIntegeration.Checked = True
                Case ModuleMain.FileOpenStyleExternalExceptionUseExternal : Me.rdoFileExternalRtfUseExternal.Checked = True
                Case Nothing : Me.rdoFileIntegration.Checked = False : Me.rdoFileExternalRtfUseIntegeration.Checked = False : Me.rdoFileExternalRtfUseExternal.Checked = False
            End Select
            Me.lstFileOpenStyleException.Items.Clear()
            If FileOpenStyleException <> "NoException" Then
                For Each i As String In ExceptionList
                    If i <> Nothing And i <> "" Then Me.lstFileOpenStyleException.Items.Add(i)
                Next
            End If
        Else
            Me.chkTopMostForm.Checked = frmMain.TopMost
            Me.chkWordWrap.Checked = ModuleMain.NewForm.rtxMain.WordWrap
            Me.chkFileToopTips.Checked = frmMain.tvwFile.ShowNodeToolTips
        End If
        Me.trbOpacity.Value = frmMain.Opacity * 100
    End Sub

    Private Sub btnFileOpenStyleAddException_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFileOpenStyleAddException.Click
        Dim ListArray(Me.lstFileOpenStyleException.Items.Count) As String, Text As String = Nothing
        If Me.txtFileOpenStyleException.Text.IndexOf(".", 1) = -1 And Me.txtFileOpenStyleException.Text.StartsWith(".") = True Then
            Me.lstFileOpenStyleException.Items.Add(Me.txtFileOpenStyleException.Text)
            Me.lstFileOpenStyleException.Items.CopyTo(ListArray, 0)
            Dim Number As Integer
            For Each i As String In ListArray
                If Number = ListArray.Length - 1 Then : Text &= "|" & i
                ElseIf Number = 0 Then : Text &= i & "|"
                Else : Text &= "|" & i & "|"
                End If
                Number += 1
            Next
            Text &= "|||" : Me.txtFileOpenStyleException.Text = ""
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyleException", Text.Remove(Text.IndexOf("|||")), Microsoft.Win32.RegistryValueKind.String)
        Else
            MessageBox.Show("文件格式语法错误,请重新输入。", "错误", MessageBoxButtons.OK, MessageBoxIcon.Error) : Me.txtFileOpenStyleException.Text = ""
        End If
    End Sub

    Private Sub btnFileOpenStyleDeleteException_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFileOpenStyleDeleteException.Click
        Me.lstFileOpenStyleException.Items.RemoveAt(Me.lstFileOpenStyleException.SelectedIndex)
        Dim ListArray(Me.lstFileOpenStyleException.Items.Count) As String, Text As String = Nothing, Number As Integer
        Me.lstFileOpenStyleException.Items.CopyTo(ListArray, 0)
        If ListArray(0) IsNot Nothing Then
            For Each i As String In ListArray
                If Number = ListArray.Length - 1 Then : Text &= "|" & i
                ElseIf Number = 0 Then : Text &= i & "|"
                Else : Text &= "|" & i & "|"
                End If
                Number += 1
            Next
            Text &= "|"
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyleException", Text.Remove(Text.IndexOf("|||")), Microsoft.Win32.RegistryValueKind.String)
        Else
            My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\Software\SmallEdit\Options", "FileOpenStyleException", "NoException", Microsoft.Win32.RegistryValueKind.String)
        End If
    End Sub

    Private Sub lstFileOpenStyleException_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFileOpenStyleException.SelectedIndexChanged
        If Me.lstFileOpenStyleException.SelectedIndex <> -1 Then Me.btnFileOpenStyleDeleteException.Enabled = True Else Me.btnFileOpenStyleDeleteException.Enabled = False
    End Sub

    Private Sub txtFileOpenStyleException_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFileOpenStyleException.TextChanged
        If Me.txtFileOpenStyleException.Text <> Nothing Then Me.btnFileOpenStyleAddException.Enabled = True Else Me.btnFileOpenStyleAddException.Enabled = False
    End Sub

    Private Sub rdoFileIntegration_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoFileIntegration.CheckedChanged
        If Me.rdoFileIntegration.Checked = True Then Me.lstFileOpenStyleException.Enabled = False : Me.txtFileOpenStyleException.Enabled = False : Me.btnFileOpenStyleAddException.Enabled = False : Me.btnFileOpenStyleDeleteException.Enabled = False
    End Sub

    Private Sub rdoFileExternalRtfUseIntegeration_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoFileExternalRtfUseIntegeration.CheckedChanged
        If Me.rdoFileExternalRtfUseIntegeration.Checked = True Then Me.lstFileOpenStyleException.Enabled = True : Me.txtFileOpenStyleException.Enabled = True
    End Sub

    Private Sub rdoFileExternalRtfUseExternal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoFileExternalRtfUseExternal.CheckedChanged
        If Me.rdoFileExternalRtfUseExternal.Checked = True Then Me.lstFileOpenStyleException.Enabled = True : Me.txtFileOpenStyleException.Enabled = True
    End Sub
End Class
